#include <stdio.h>
#include <stdlib.h>
#include <pthread.h>
#include <math.h>
#include <unistd.h>

pthread_mutex_t mutex = PTHREAD_MUTEX_INITIALIZER;

void * run_thread(int number)
{
	for(unsigned int i=0 ; i<10 ; i++)
	{
		pthread_mutex_lock(&mutex);
		printf("Thread %d sleeping...\n",number);
		sleep(1);
		printf("Thread %d waking...\n",number);
		pthread_mutex_unlock(&mutex);
	}
	return 0;
}

int main(void)
{
	pthread_t thread1, thread2;
	pthread_create(&thread1, NULL, (void*(*)(void*))run_thread, (void*)1);
	pthread_create(&thread2, NULL, (void*(*)(void*))run_thread, (void*)2);
	pthread_join(thread1, NULL);
	pthread_join(thread2, NULL);
	return 0;
}
